<?php  if ( ! defined('ACCESS')) exit('No direct script access allowed');
	
	/**
	 * comments.php
	 * Module comments to pages
	 * @package Template CMS	 
	 * @version 1.1
	 * @copyright Sergey Romanenko / Awilum / www.webdevart.ru, 2010
	 * 
	 */
	
	/**
	 * Initialize main comments actions
	 * @return NULL
	 */	
	function main_comments_actions() {
		global $comment_error;
		
		// Actions
		if(isset($_POST['submit_comment'])) {
			$name = trim($_POST['name']);
			$email = trim($_POST['email']);
			$message = trim($_POST['message']);
			if((empty($name)) or (empty($email)) or (empty($message)) or (!isset($_POST['i_am_not_a_robot']))) {
				$comment_error = TRUE;
				header("location: ".$_POST['page_url']);	
			} else {
				add_comment($_POST['name'],$_POST['email'],$_POST['message'],mktime(),$_POST['page_url']);	
				header("location: ".$_POST['page_url']);
			}		
		}
	}

	/**
	 * Initialize admin comments actions
	 * @return NULL
	 */	
	function admin_comments_actions() {
		// Actions
		if(isset($_GET['delete_comment'])) {
			delete_comment('../data/site/comments_'.clean_url($_GET['delete_comment']).'.htm',clean_url($_GET['delete_comment']),clean_url($_GET['id']));
		}
	}	
	
	/**
	 * This function show all comments to current page add add form
	 * @return NULL
	 */	
	function show_comments() {
		global $txt;
		global $comment_error;
		
	 	$comments = file('data/site/comments_'.page_url().'.htm');
	 	
	 	echo '<h2>'.$txt['comments'].' ('.count($comments).')</h2><br />';
	 	

	 	$count = count($comments)-1;
 	
		for($i=0;$i<=$count;$i++) {
			list($name,$email,$message,$date) = explode("{break}",$comments[$i]);
			echo '<table class="comm">';
			echo '<tr><th>';
			echo '<b>'.$name.'</b> ( '. date('H:i:s / j.n.Y',$date).' ) '.'';
			echo '</th></tr>';
			echo '<tr><td >';
			echo parse_bbc(stripslashes(htmlspecialchars($message)));
			echo '</td></tr>';
			echo '</table>';
	 	}		 	
	 	
	 	if(isset($_POST['name'])) $post_name = $_POST['name']; else $post_name = '';
	 	if(isset($_POST['email'])) $post_email = $_POST['email']; else $post_email = '';
	 	if(isset($_POST['message'])) $post_message = $_POST['message']; else $post_message = '';
	 	
 	
		echo '<h3 class="add_comm">'.$txt['comment'];
		if($comment_error == TRUE) echo ' ( <font color="red">'.$txt['comments_fields_error'].'</font> ) ';
		echo '</h3>';
		echo '<form action="index.php" method="post">
				<table class="add_comm">				
				<input type="hidden" name="page_url" value="'.page_url().'">
	 			<tr><td>'.$txt['comments_name'].': </td><td><input type="text" name="name" value="'.$post_name.'" /></td></tr>
	 			<tr><td>'.$txt['comments_email'].': </td><td><input type="text" name="email" value="'.$post_email.'" /> ('.$txt['comments_not_published'].') </td></tr>
	 			</table>	 				 			
		 			<textarea name="message" cols="50" rows="5">'.$post_message.'</textarea><br />';
		 		echo '<span style="color:#333; font-size:10px;" >'."[b][/b]&nbsp;&nbsp;[i][/i]&nbsp;&nbsp;[u][/u]&nbsp;&nbsp;[s][/s]&nbsp;&nbsp;[br]&nbsp;&nbsp;[url=][/url]&nbsp;&nbsp;[quote][/quote]".'</span><br /><br />
				'.$txt['i_am_not_a_robot'].'<input type="checkbox" name="i_am_not_a_robot" value=""><br />
	 			<input type="submit" name="submit_comment" value="'.$txt['comments_submit'].'" />
			  </form>';		 	
	}

	/**
	 * This function add comment
	 * @param string $name user name
	 * @param string $email user email
	 * @param string $message user message
	 * @param int $date unix TIMESTAMP
	 * @param string $page_url page url
	 * @return NULL
	 */		 
	function add_comment($name,$email,$message,$date,$page_url) {
		$handle = fopen('data/site/comments_'.$page_url.'.htm',"a");
		flock ($handle,LOCK_EX);
		$content = clear_break($name).'{break}'.clear_break($email).'{break}'.removenlbr(clear_break($message)).'{break}'.$date.'{break}'."\n";
		fputs($handle,$content);
		fflush ($handle);
		flock ($handle,LOCK_UN);
		fclose ($handle);		
	}	 
	
	/**
	 * Create comments file comment_pagename.htm
	 * @param string $file comments file
	 * @return NULL
	 */
	function create_comments_file($file) {
		$handle = fopen ($file, "w"); 
		fwrite($handle,''); 
		fclose($handle);	
	}
	
	/**
	 * Delete comments file 
	 * @param string $file comments file
	 * @return NULL
	 */
	function delete_comments_file($file) {
		unlink('../data/site/comments_'.basename($file,'.html').'.htm');
	}
	
	/**
	 * Delete current comment
	 * @param string $file comments file
	 * @param string $page page name
	 * @param integer $id current line to delete
	 * @return NULL
	 */
	function delete_comment($file,$page,$id) {
		$fl = $file; 
		$line = $id;
		$file = file($fl); 
		$count = count($file);
		$fp = fopen($fl,"w");
		for($i=0;$i<$count;$i++) {
			if($i!=$line) {
				fwrite($fp,$file[$i]);
			}
		}
		fclose($fp); 
		header("location: index.php?comments={$page}");		
	}
