<?php  if ( ! defined('ACCESS')) exit('No direct script access allowed');
	
	/**
	 * news.php
	 * Module site news
	 * @package Template CMS	 
	 * @version 1.3
	 * @copyright Sergey Romanenko / Awilum / www.webdevart.ru, 2010
	 * 
	 */

	
	$news_comments_status = TRUE;
	

	/**
	 * Initialize admin news actions
	 * @return NULL
	 */	
	function admin_news_actions() {
		if(isset($_GET['delete_news'])) {
			delete_news('../data/other/news/news.html',clean_url($_GET['delete_news']));
		}	

		if(isset($_POST['submit_add_news'])) {
			
			// Get News Friendly url 			
			$tmp_slug = trim($_POST['add_slug_news']);
			if(empty($tmp_slug)) {
				$slug_g = str_replace(" ", "_", trim($_POST['add_title_news']));			
			} else {
				$slug_g = str_replace(" ", "_",$tmp_slug);
			}
			
					
			// Get News Title
			$title_g = trim($_POST['add_title_news']);
			if(empty($title_g)) $title_g = 'temp_'.rand(1,1000);
			
			$slug = $slug_g;
			$title = $title_g;
			
			// Check for news friendly url. If exists then slug + random number. Create unique field.
			$news_file = file('../data/other/news/news.html');			
			for($i=0;$i<=count($news_file)-1;$i++) {
				list($date_ch,$slug_ch,$title_ch,$desription_ch,$keywords_ch,$comments_ch,$msg1_ch,$msg2_ch) = explode("{break}",$news_file[$i]);
				if($slug_ch == translitIt(clear_news_title($slug))) $slug = $slug.rand(1,1000);	
		 	}	
		 			 		
			//1282316591{break}slug{break}title{break}description{break}keywords{break}TRUE{break}SHORT{break}LONG NEWS			
			add_news('../data/other/news/news.html',mktime(),
					translitIt(clear_break(clear_news_title($slug))),
					clear_break(stripslashes_if_gpc_magic_quotes($title)),
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['add_description_news'])),
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['add_keywords_news'])),
					$comments,
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['editor_kama'])),
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['editor_kama2'])));
		}

		if(isset($_POST['submit_edit_news'])) {

			// Get News Friendly url 			
			$tmp_slug = trim($_POST['edit_slug_news']);
			if(empty($tmp_slug)) {
				$slug_g = str_replace(" ", "_", trim($_POST['edit_title_news']));			
			} else {
				$slug_g = str_replace(" ", "_",$tmp_slug);
			}
			
			// Get News Title
			$title_g = trim($_POST['edit_title_news']);
			if(empty($title_g)) $title_g = 'temp_'.rand(1,1000);
			
			
			$slug = $slug_g;
			$title = $title_g;
			
			// Check for news friendly url. If exists then slug + random number. Create unique field.
			//$news_file = file('../data/other/news/news.html');			
			//for($i=0;$i<=count($news_file)-1;$i++) {
			//	list($date_ch,$slug_ch,$title_ch,$desription_ch,$keywords_ch,$comments_ch,$msg1_ch,$msg2_ch) = explode("{break}",$news_file[$i]);
			//	if($slug_ch == translitIt($slug)) $slug = $slug.rand(1,1000);	
		 	//}	
		 	// @TODO check for unique after editing
		 				
			edit_news('../data/other/news/news.html',
					$_POST['edit_date_news'],
					$_POST['edit_news_id'],
					translitIt(clear_break(clear_news_title($slug))),
					clear_break(stripslashes_if_gpc_magic_quotes($title)),
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['edit_description_news'])),
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['edit_keywords_news'])),
					$comments,
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['editor_kama'])),
					clear_break(stripslashes_if_gpc_magic_quotes($_POST['editor_kama2'])));
		}
		
		if(isset($_GET['delete_news_comment'])) {
			delete_news_comment('../data/other/news/comments.html',clean_url($_GET['delete_news_comment']));
		}
	}
	
	/**
	 * This function clean news slug
	 * @param string $text text you want to turn encode into a SLUG
	 * @return string $text clear slug
	 */	
	function clear_news_title($text) {
		$code_entities_match = array(' ','--','"','!','@','#','$','^','*','(',')','+','{','}','|' ,':','"','<','>','[',']','\\',';',"'",',','/','*','+','~','`','=','.','-'); 
		$code_entities_replace = array('','','','','','','','','','','','','','','','','','','','','','',''); 
		$text = str_replace($code_entities_match, $code_entities_replace, $text); 
		return $text; 	
	}

	
	/**
	 * Initialize main comments actions
	 * @return NULL
	 */	
	function main_news_actions() {		
		global $comment_error,$friendly_urls,$slug,$site_meta_data;
		
		// Actions
		if(isset($_POST['submit_news_comment'])) {			
			$name = trim($_POST['name']);
			$email = trim($_POST['email']);
			$message = trim($_POST['message']);
			if((empty($name)) or (empty($email)) or (empty($message)) or (!isset($_POST['i_am_not_a_robot']))) {
				$comment_error = TRUE;
				if($friendly_urls == true) {
					header("location: ".$_POST['news_url'].$slug.$site_meta_data[6]);	
				} else {
					header("location: index.php?page=".$_POST['news_url']);	
				}
			} else {
				add_news_comment($_POST['name'],$_POST['email'],$_POST['message'],mktime(),$_POST['news_url']);
				if($friendly_urls == true) {
					header("location: ".$_POST['news_url'].$slug.$site_meta_data[6]);	
				} else {
					header("location: index.php?page=".$_POST['news_url']);	
				}			
			}		
		}		
	}
	
	/**
	 * Create comments file comment_pagename.htm
	 * @param string $file comments file
	 * @return NULL
	 */
	function create_news_comments_file($file) {
		$handle = fopen ($file, "w"); 
		fwrite($handle,''); 
		fclose($handle);	
	}
	
	/**
	 * Delete comments file 
	 * @param string $file comments file
	 * @return NULL
	 */
	function delete_news_comments_file($file) {
		unlink('../data/other/news/comments_'.basename($file,'.html').'.htm');
	}


	/**
	 * Show last news/posts
	 * @param count $integer news/posts limit
	 * @return NULL
	 */	
	function get_last_news($count=1) {
		global $txt,$friendly_urls,$site_meta_data;
		
	 	$news = file('data/other/news/news.html');
	 	rsort($news);	 	
	 	$total = count($news)-1;
	 	$count --;
	 	if($count > $total) $count = $total;	 				
		for($i=0;$i<=$count;$i++) {
			list($date,$slug,$title,$keywords,$description,$comments,$msg_short,$msg_long) = explode("{break}",$news[$i]);
			//echo date('j.n.Y',$date).' - <a href="news_'.$slug.'">'.$title.'</a> <br />'.$msg_short.'<br />';	
			echo '<div class="side_news"><h3><a href="'; if($friendly_urls == true){ echo 'news_'.$slug.$site_meta_data[6]; } else { echo '?page=news_'.$slug; } echo'">'.$title.'</a> </h3><p class="date">'.date('j.n.Y',$date).'</p> '.$msg_short.'</div>';	
			
	 	}		 	 	
	 	echo '<div class="archive"><a href="'; if($friendly_urls == true){ echo 'news_archive'.$site_meta_data[6]; } else { echo 'index.php?page=news_archive'; }  echo '">'; echo $txt['news_archive'].'</a></div>';
	}

	/**
	 * Function returns list of all news/posts
	 * @return string $data all news
	 */	
	function get_all_news() {
		global $friendly_urls,$slug,$site_meta_data;
		
		$data = '';		
	 	$news = file('data/other/news/news.html');	 	
	 	rsort($news);	 	
	 	$count = count($news)-1;		 	
		for($i=0;$i<=$count;$i++) {
			list($date,$slug,$title,$keywords,$description,$comments,$msg_short,$msg_long) = explode("{break}",$news[$i]);
			if($friendly_urls == true){ $tmp = 'news_'.$slug.$site_meta_data[6]; } else { $tmp = 'index.php?page=news_'.$slug; } 
			$link = '<h3><a href="'.$tmp.'">'.$title.'</a></h3>';
			$data .= '<div class="news">'.$link.'<p class="date">'.date('j.n.Y',$date).'</p>'.$msg_short.'</div>';	
	 	}		 	
		return $data;
	}

	
	/**
	 * Add current news comment
	 * @param string $name user name
	 * @param string $email user email
	 * @param string $message user message
	 * @param int $date unix TIMESTAMP
	 * @param string $news_url news url
	 * @return NULL
	 */		 	
	function add_news_comment($name,$email,$message,$date,$news_url) {
		$handle = fopen('data/other/news/comments.html',"a");
		flock ($handle,LOCK_EX);
		$content = substr($news_url, 5).'{break}'.clear_break($name).'{break}'.clear_break($email).'{break}'.removenlbr(clear_break($message)).'{break}'.$date.'{break}'."\n";
		fputs($handle,$content);
		fflush ($handle);
		flock ($handle,LOCK_UN);
		fclose ($handle);
		
	}	 

	/**
	 * Delete current news comment
	 * @param string $file current news comments file
	 * @param id $integer field id to delete
	 * @return NULL
	 */		
	function delete_news_comment($file,$id) {
		$fl = $file; 
		$line = $id;
		$file = file($fl); 
		$count = count($file);
		$fp = fopen($fl,"w");
		for($i=0;$i<$count;$i++) {
			if($i!=$line) {
				fwrite($fp,$file[$i]);
			}
		}
		fclose($fp); 
		header("location: index.php?news&comments");	
	}
	
	
	/**
	 * Get current news/post 
	 * @param string $page current news url
     * @return string of current news content
	 */	
	function get_current_news($page) {
		global $txt, $comment_error, $news_comments_status;
		
		
		// load news data file
		$news_contents = file('data/other/news/news.html');
		// load news comments data file
		$comments_f = file('data/other/news/comments.html');
		
		// Initalize variables
		$comments_content = '';
		$news_content = '';
		$news_comments = 0;
				
		// Get current news/post
		for($i=0;$i<=count($news_contents)-1;$i++) {
			list($date,$slug,$title,$keywords,$description,$comments,$msg_short,$msg_long) = explode("{break}",$news_contents[$i]);
			if($slug == substr($page, 5)) { // SELECT * FROM news_contents WHERE slug=page 				 
				$news_content = '<div class="full_news"><p class="date">'.date('j.n.Y',$date).'</p>'.$msg_long.'<p class="back"><a href="javascript:history.back()">Назад </a></p></div>'; 
			}			
		}					
		
		// Get comments 
		for($i=0;$i<=count($comments_f)-1;$i++) {
			list($id,$name,$email,$message,$date) = explode("{break}",$comments_f[$i]);
			if($id == substr($page, 5)) { // SELECT * FROM comments_f WHERE slug=page 				 
				$news_comments++; // count news comments	
				$comments_content .= '<table class="comm">
				<tr><th>
				<b>'.$name.'</b> ( '. date('H:i:s / j.n.Y',$date).' ) '.'
				</th></tr>
				<tr><td style="padding:.5em;">
				'.parse_bbc(stripslashes(htmlspecialchars($message))).'
				</td></tr>
				</table>';
			}
	 	}	
	 	
	 	if($news_comments_status) { $news_comments_content = '<h3 class="comments">'.$txt['comments'].' ('.$news_comments.')</h3>'; }
	 	
	 		 	
	 	if(isset($_POST['name'])) $post_name = $_POST['name']; else $post_name = '';
	 	if(isset($_POST['email'])) $post_email = $_POST['email']; else $post_email = '';
	 	if(isset($_POST['message'])) $post_message = $_POST['message']; else $post_message = '';
		
		if($comment_error == TRUE) echo ' ( <font color="red">'.$txt['comments_fields_error'].'</font> ) ';

		if($news_comments_status) {
		// Comments form
		$commentform_content = '<h3 class="add_comm">'.$txt['comment'].'
		</h3>
		<form action="index.php" method="post">
							
				<input type="hidden" name="news_url" value="'.page_url().'">
	 			<p><label>'.$txt['comments_name'].':</label><input type="text" name="name" value="'.$post_name.'" /></p>
	 			<p><label>'.$txt['comments_email'].':</label><input type="text" name="email" value="'.$post_email.'" /> ('.$txt['comments_not_published'].')</p> 
		 		<p><label>'.$txt['contact_message'].': </label><textarea name="message" cols="" rows="">'.$post_message.'</textarea><br />
		 		<span style="color:#333; font-size:10px;" >'."[b][/b]&nbsp;&nbsp;[i][/i]&nbsp;&nbsp;[u][/u]&nbsp;&nbsp;[s][/s]&nbsp;&nbsp;[br]&nbsp;&nbsp;[url=][/url]&nbsp;&nbsp;[quote][/quote]".'</span><br /><br /></p>
	 			<p><input type="checkbox" name="i_am_not_a_robot" value="">'.$txt['i_am_not_a_robot'].'</p>
		 		<p><input type="submit" name="submit_news_comment" value="'.$txt['comments_submit'].'" /></p>
			  </form>';	
		} else {
			$commentform_content = '';
		}
		
		return $news_content.$news_comments_content.$comments_content.$commentform_content;
	}
	
	
	/**
	 * Get news meta data
	 * @param string $file news file
	 * @param string $page current news url
     * @return array $news_data of news meta
	 */	
	function get_news_meta($page) {
		$news_data = array();		
		$news = strpos($page,'news_');
		
		if($page == 'news_archive') $news_data[2] ='Новости';
		
		if ($news === 0) { 
			if(file_exists('data/other/news/news.html')) {
				$news_file = file('data/other/news/news.html');
				for($i=0;$i<=count($news_file)-1;$i++) {
					list($date,$slug,$title,$description,$keywords,$comments,$msg_short,$msg_long) = explode("{break}",$news_file[$i]);
					if($slug == substr($page, 5)) { 
						$news_data[2] = $title; 
						$news_data[3] = $description; 
						$news_data[4] = $keywords; 
					}			
				}					
			} else {

			}				
		}			
		return $news_data;
	}
	
		
	/**
	 * Add news
	 * @param string $file news file
	 * @param string $date news date 
	 * @param string $slug friendly url
	 * @param string $title news title
	 * @param string $description news description
	 * @param string $keywords news keywords
	 * @param string $msg_short short version
	 * @param string $msg_long long version
	 * @return NULL
	 */	
	function add_news($file,$date,$slug,$title,$description,$keywords,$comments,$msg_short,$msg_long) {
		$handle = fopen($file,"a");
		flock ($handle,LOCK_EX);
		$content = $date.'{break}'.$slug.'{break}'.$title.'{break}'.$description.'{break}'.$keywords.'{break}'.$comments.'{break}'.removenlbr($msg_short).'{break}'.removenlbr($msg_long).'{break}'."\n";
		fputs($handle,$content);
		fflush ($handle);
		flock ($handle,LOCK_UN);
		fclose ($handle);
		header("location: index.php?news");
	}

	/**
	 * Edit current news
	 * @param string $file news file
	 * @param string $date news date 
	 * @param integer $id current line to edit
	 * @param string $slug friendly url
	 * @param string $title news title
	 * @param string $description news description
	 * @param string $keywords news keywords
	 * @param string $msg_short short version
	 * @param string $msg_long long version
	 * @return NULL
	 */	
	function edit_news($file,$date,$id,$slug,$title,$description,$keywords,$comments,$msg_short,$msg_long) {
		$fl = $file; 
		$line = $id;		
		$content = strtotime($date).'{break}'.$slug.'{break}'.$title.'{break}'.$description.'{break}'.$keywords.'{break}'.$comments.'{break}'.removenlbr($msg_short).'{break}'.removenlbr($msg_long).'{break}'."\n";
		$file = file($fl); 
		$count = count($file); 
		$fp = fopen($fl,"w");
		for($i=0;$i<$count;$i++) {
			if($i!=$line) {
				fwrite($fp,$file[$i]);
			} else {
				fwrite($fp,$content);
			}
		}
		fclose($fp); 
		header("location: index.php?news");
	}
	
	/**
	 * Delete current news
	 * @param string $file news file
	 * @param integer $id current line to delete
	 * @return NULL
	 */
	function delete_news($file,$id) {
		$fl = $file; 
		$line = $id;
		$file = file($fl); 
		$count = count($file);
		$fp = fopen($fl,"w");
		for($i=0;$i<$count;$i++) {
			if($i!=$line) {
				fwrite($fp,$file[$i]);
			}
		}
		fclose($fp); 
		header("location: index.php?news");		
	}
	
